#include "hmg.ch"

function Main()

	DEFINE WINDOW Win_1			;
	        AT        0,0 			;
	        WIDTH     640 			;
        	HEIGHT    480 			;
	        TITLE     "Roman Figure Demo" 	;
        	MAIN 				;
		  		BACKCOLOR GRAY

		DEFINE MAIN MENU OF Win_1
        		POPUP "&Demo"
		                  ITEM "&Roman Figure Demo" ACTION msginfo("Function" + Chr( 13 ) + ; 
		                                                           "-------------" + Chr( 13 ) + ; 
		                                                           "RomanNum(2011)" + Chr( 13 ) + ;
		                                                           "RomanNum('325')" + Chr( 13 ) + ;
		                                                           "RomanNum('mmml')" + Chr( 13 ) + ;
		                                                           "RomanNum('CIX')" + Chr( 13 ) + Chr( 13 ) + ; 
		                                                           "Result" + Chr( 13 ) + ; 
		                                                           "-------------" + Chr( 13 ) + ; 
		                                                            RomanNum(2011) + Chr( 13) + ;
		                                                            RomanNum('325') + Chr( 13) +;
		                                                            RomanNum('mmml') + Chr( 13) +;
		                                                            RomanNum('CIX'), ;
		                                                            "Use of Roman Function")
		                  
/*                		ITEM "&Roman Figure Demo" ACTION msginfo("Function: RomanNum(1998)  Result: " + RomanNum(1998) + Chr( 13 ) + Chr( 13 ) + ;
                            "Function: RomanNum('325')  Result: " + RomanNum('325') + Chr( 13 ) + Chr( 13 ) + ;
                             "Function: RomanNum("mmml")  Result: " + RomanNum("mmml") + Chr( 13 ) + Chr( 13 ) + ;
                             "Function: RomanNum("CIX")  Result: " + RomanNum("CIX"))
                                
                		  ITEM "&Roman Figure Demo" ACTION msginfo("Function: RomanNum(1998)  Result: " + RomanNum(1998) + Chr( 13) + ;
                		                          "Function: RomanNum('325')  Result: " + RomanNum('325') + Chr( 13) + ;
                		                          "RomanNum("mmml")  Result: " + "RomanNum("mmml")" + Chr( 13) + ;
                		                          "Function: RomanNum('CIX')  Result: " +" RomanNum("CIX") ")
*/                                
		        END POPUP
		END MENU
    ON KEY ESCAPE ACTION Win_1.Release
	END WINDOW

	MAXIMIZE WINDOW Win_1
	ACTIVATE WINDOW Win_1

Return Nil

/*---------------------------*/
*:*****************************************************************************
*:
*:       Function: ROMANNUM()
*:         Author: Richard A. Pulliam
*:      Copyright (c) 1996, Richard A. Pulliam
*:  Last modified: 06/29/96     11:19
*:
*:  Procs & Fncts: ROMANNUM()
*:               : VALIDROMAN()
*:
*:          Calls: VALIDROMAN()       (function  in ROMANNUM.PRG)
*:
*:  This function returns a roman numberal or a string integer
*:  depending in the type of uVal.  If returning a Roman numeral,
*:  by default it will return it in uppercase.
*:
*:  Valid string or number passed to it can be up to integer 3999.
*:
*:  Example:
*:
*:     CLS
*:     ? RomanNum(1998)
*:     ? RomanNum('325')
*:     ? RomanNum("mmml")
*:     ? RomanNum("CIX")
*:     INKEY(0)
*:
*:*****************************************************************************
#INCLUDE "COMMON.CH"
#DEFINE aRoman {'I','II','III','IV','V','VI','VII','VIII','IX','X','XX',;
'XXX','XL','L','LX','LXX','LXXX','XC','C','CC','CCC','CD','D','M','MC',;
'MCC','MCCC','MCD','MD','MDC','MDCC','MDCCC','MCM','MM','MMM'}
#DEFINE aInt {1,2,3,4,5,6,7,8,9,10,20,30,40,50,60,70,80,90,100,200,300,;
400,500,1000,1100,1200,1300,1400,1500,1600,1700,1800,1900,2000,3000}

FUNCTION RomanNum(uVal,lReturnUpperCase)
/*
   Added to UDF.LIB
*/
LOCAL cRetVal:='',nVal,nRemain,nPrecede,nPos,nFoundPos,I,cSearchVal,cMatch
LOCAL cVal

DEFAULT lReturnUpperCase TO TRUE

IF (VALTYPE(uVal)=='C')
   uVal:=ALLTRIM(uVal)
ELSEIF (VALTYPE(uVal)=='N')
   uVal:=ALLTRIM(STR(uVal))
ELSE
   MSGinfo('You can only pass Number or Character string to RomanNum()')
   RETURN('')
ENDIF (VALTYPE(uVal)=='C')

IF (VAL(ALLTRIM(uVal))>0) // an integer as string passed to function
   nVal:=VAL(uVal)
   IF (nVal>=4000) // error
      MSGinfo('Maximum integer allowed is 3999 in RomanNum()')
      RETURN('')
   ENDIF (nVal>=4000)
   * initialize return value if greater than 1000
   IF (nVal>1000 .AND. nVal < 2000)
      cRetVal:='M'
      nVal-=1000
   ELSEIF (nVal>=2000 .AND. nVal < 3000)
      cRetVal:='MM'
      nVal-=2000
   ELSEIF (nVal>=3000 .AND. nVal < 4000)
      cRetVal:='MMM'
      nVal-=3000
   ENDIF (nVal>1000 .AND. nVal < 2000)
   WHILE(TRUE) // set a loop to obtain values
      IF (nVal == 0)
         RETURN(IF(lReturnUpperCase,UPPER(cRetVal),LOWER(cRetVal)))
      ELSEIF (nVal >= 1 .AND. nVal <= 10)
         cRetVal+=aRoman[nVal]
         RETURN(IF(lReturnUpperCase,UPPER(cRetVal),LOWER(cRetVal)))
      ELSEIF (nVal >= 11 .AND. nVal<=100)
         nRemain:=nVal%10
         nPrecede:=nVal-nRemain
         nPos:=ASCAN(aInt,nPrecede,1,LEN(aInt))
         IF (nPos>0)
            cRetVal+=aRoman[nPos]+IF(nRemain==0,'',aRoman[nRemain])
            RETURN(IF(lReturnUpperCase,UPPER(cRetVal),LOWER(cRetVal)))
         ENDIF (nPos>0)
      ELSEIF (nVal >= 101 .AND. nVal <= 199)
         cRetVal+='C'
         nVal-=100
      ELSEIF (nVal >= 200 .AND. nVal <= 299)
         cRetVal+='CC'
         nVal-=200
      ELSEIF (nVal >= 300 .AND. nVal <= 399)
         cRetVal+='CCC'
         nVal-=300
      ELSEIF (nVal >= 400 .AND. nVal <= 499)
         cRetVal+='CD'
         nVal-=400
      ELSEIF (nVal >= 500 .AND. nVal <= 599)
         cRetVal+='D'
         nVal-=500
      ELSEIF (nVal >= 600 .AND. nVal <= 699)
         cRetVal+='DC'
         nVal-=600
      ELSEIF (nVal >= 700 .AND. nVal <= 799)
         cRetVal+='DCC'
         nVal-=700
      ELSEIF (nVal >= 800 .AND. nVal <= 899)
         cRetVal+='DCCC'
         nVal-=800
      ELSEIF (nVal >= 900 .AND. nVal <= 999)
         cRetVal+='CM'
         nVal-=900
      ELSEIF nVal = 1000
         cRetVal+='M'
         nVal-=1000
      ENDIF (nVal == 0)
   ENDDO
ELSE // Roman numeral
   cVal:=UPPER(ALLTRIM(uVal))
   IF (!ValidRoman(cVal))
      MSGinfo(cVal+' is not a valid Roman Numeral in RomanNum()')
      RETURN('')
   ENDIF (!ValidRoman(cVal))
   nFoundPos:=nRetval:=0
   WHILE(TRUE)
      FOR I:=1 TO LEN(cVal)
         cSearchVal:=LEFT(cVal,I)
         nPos:=ASCAN(aRoman,cSearchVal,1,LEN(aRoman))
         IF (nPos>0)
            nFoundPos:=nPos
         ELSE
            EXIT
         ENDIF (nPos>0)
      NEXT (I:)
      IF (aRoman[nFoundPos]==cVal)
         cRetVal:=ALLTRIM(STR(nRetVal+aInt[nFoundPos]))
         RETURN(IF(lReturnUpperCase,UPPER(cRetVal),LOWER(cRetVal)))
      ELSE
         nRetVal+=aInt[nFoundPos]
         cMatch:=aRoman[nFoundPos]
         cVal:=SUBSTR(cVal,LEN(cMatch)+1)
      ENDIF (aRoman[nFoundPos]==cVal)
   ENDDO
ENDIF (aRoman[nFoundPos]==cVal)

*!*****************************************************************************
*!
*!       Function: VALIDROMAN()
*!
*!  Validates that all characters passed to it are valid roman numerals
*!
*!      Called by: ROMANNUM()         (function  in ROMANNUM.PRG)
*!
*!*****************************************************************************
#DEFINE ROMAN_NUMERALS 'IVXLCDM'

STATIC FUNCTION ValidRoman(cVal)
LOCAL I

cVal:=UPPER(ALLTRIM(cVal))
IF (EMPTY(cVal))
   RETURN(FALSE)
ENDIF (EMPTY(cVal))

FOR I:=1 TO LEN(cVal)
   IF !SUBSTR(cVal,I,1) $ ROMAN_NUMERALS
      RETURN(FALSE)
   ENDIF (!SUBSTR(cVal,I,1) $ ROMAN_NUMERALS)
NEXT (I:)
RETURN(TRUE)
